import javax.ejb.*         ;
import java.util.*         ;
import java.math.BigDecimal;

/////////////////////////////////////////////////////////////////////
//
//  Fields to check.        
//
//sideKey
//quantityKey
//durationKey
//order_typeKey
/////////////////////////////////////////////////////////////////////

public class fieldLevelValidationBean implements javax.ejb.SessionBean
{
     protected   SessionContext m_context;

	public void setSessionContext(javax.ejb.SessionContext sessionContext)
	{
		m_context = sessionContext;
	}
	public void ejbCreate   () throws CreateException {}
	public void ejbRemove   () {}
	public void ejbActivate () {}
	public void ejbPassivate() {}

    public Hashtable isValid(Hashtable hParms)
    {
    	System.out.println(this+" Inside  isValid"); System.out.flush();
    	
    	Hashtable hValidationReturn = new Hashtable ();
    	
    	System.out.println(this+" hParms = [" + hParms + "]"); System.out.flush();	
    	
    	hValidationReturn.put ( "returnCode", "0" );
    	
        for ( Enumeration enumHParms = hParms.keys(); enumHParms.hasMoreElements(); )
        {
    		String sHashKey = (String) enumHParms.nextElement ();
    
            System.out.println(this+" hParms            = [" + hParms             + "]"); System.out.flush();		
            System.out.println(this+" hValidationReturn = [" + hValidationReturn  + "]"); System.out.flush();		
            System.out.println(this+" sHashKey          = [" + sHashKey           + "]"); System.out.flush();		
    
            //////////////////////////////////////////////////////////////////////////            //                     sideKey     //////////////////////////////////////////////////////////////////////////
    	    if ( sHashKey.equals("sideKey") )
            {
                System.out.println(this+" inside if ( sHashKey " );
                System.out.println(this+" (String) hParms.get (sHashKey) = [" + (String) hParms.get (sHashKey) +"]" );
    
                if ( !(    ((String) hParms.get (sHashKey)).equals("B")         // Buy
                        || ((String) hParms.get (sHashKey)).equals("S")         // Sell
                        || ((String) hParms.get (sHashKey)).equals("H")         // Hold
                      )
    				)
                    {
                	hValidationReturn.put ( "returnCode"  , "-1" );
            		hValidationReturn.put ( "returnString", "Please choose a side (e.g. B to Buy, S to Sell or H to Hold for "+(String) hParms.get ("symbolKey")+".");
                    System.out.println(this+" hValidationReturn = [" + hValidationReturn + "]"); System.out.flush();
    				System.out.println(this+" Leaving  isValid - false sideKey"); System.out.flush();
            		return hValidationReturn;
                    }
    
                System.out.println(this+" past  if ( !(    (String) hParms.get (sHashKey) == " );
            }                 
    
            //////////////////////////////////////////////////////////////////////////
//                         quantityKey            //////////////////////////////////////////////////////////////////////////
            else if ( sHashKey.equals("quantityKey") )
                {
                if (    (String) hParms.get (sHashKey) == null
                    || ((String) hParms.get (sHashKey)).equals ("")
                   )
                    {
                	hValidationReturn.put ( "returnCode"  , "-1" );
            		hValidationReturn.put ( "return String", "Error: No Quantity entered for "+(String) hParms.get ("symbolKey")+".");
    				System.out.println(this+" Leaving  isValid - false quantityKey 1"); System.out.flush();
            		return hValidationReturn;
                    }
                Double dbQuantity = new Double ((String) hParms.get (sHashKey));
                if (   dbQuantity.intValue() <= 0 )
                    {
                	hValidationReturn.put ( "returnCode"  , "-1" );
            		hValidationReturn.put ( "returnString", "Error: invalid Quantity, "+dbQuantity.intValue()+", for "+(String) hParms.get ("symbolKey")+"");
    				System.out.println(this+" Leaving  isValid - false Key 2"); System.out.flush();        		
    				return hValidationReturn;
                    }
                }
//////////////////////////////////////////////////////////////////////////            //                         account_typeKey
            //////////////////////////////////////////////////////////////////////////
            else if ( sHashKey.equals("account_typeKey" ) )
                {
                String    AccountType  = (String) hParms.get (sHashKey);
                if ( !(   AccountType.equals("10")  // Prefered
                       || AccountType.equals("20")  // Expert 
                       || AccountType.equals("30")  // Super Expert 
                      )
                   )
                    {
                	hValidationReturn.put ( "returnCode"  , "-1" );
            		hValidationReturn.put ( "returnString", "Error, Account Type " + AccountType +" must be Cash, Margin or Short for "+(String) hParms.get ("symbolKey")+".");
    				System.out.println(this+" Leaving  isValid - false account_typeKey"); System.out.flush();
            		return hValidationReturn;
                    }
                }
    
            
            //////////////////////////////////////////////////////////////////////////            //                         durationKey
            //////////////////////////////////////////////////////////////////////////
            else if ( sHashKey.equals("durationKey" ) )
                {
                String Duration = (String) hParms.get (sHashKey);
                    
                if ( ! (   Duration.equals("Day")
                        || Duration.equals("Month")
                        || Duration.equals("Year")            
                       )
                   )
                    {
                	hValidationReturn.put ( "returnCode"  , "-1" );
            		hValidationReturn.put ( "returnString", "Error, Invalid Duration " + Duration + " for "+(String) hParms.get ("symbolKey")+".");
    				System.out.println(this+" Leaving  isValid - false durationKey"); System.out.flush();
            		return hValidationReturn;
                    }
                }
    
    
            //////////////////////////////////////////////////////////////////////////            //                         order_typeKey
            //////////////////////////////////////////////////////////////////////////
            else if ( sHashKey.equals("order_typeKey" ) )
                {
                String orderType = (String) hParms.get (sHashKey);
                    
                if ( ! (   orderType.equals("Q")      // Quick
                        || orderType.equals("S")      // Slow
                       )
                   )
                    {
                	hValidationReturn.put ( "returnCode"  , "-1" );
            		hValidationReturn.put ( "returnString", "Error, Invalid Order Type " + orderType + " for "+(String) hParms.get ("symbolKey")+".");
    				System.out.println(this+" Leaving  isValid - false order_typeKey"); System.out.flush();
            		return hValidationReturn;
                    }
                }
    
            } // for ( Enumeration enumHParms = hParms.keys(); enumHParms.hasMoreElements(); )
         
    	System.out.println(this+" Leaving  isValid - true"); System.out.flush();
    	  
        return hValidationReturn;
	} // public Hashtable isValid(Hashtable hParms)

    public void businessMethod2 (String sInput)
    {
System.out.println(this+" Inside  businessMethod2. sInput = ["+sInput+"]");
System.out.flush();
}
	
}
