package destination;

import javax.jms.Queue;
import javax.jms.QueueConnectionFactory;

import javax.naming.Context;
import javax.naming.InitialContext;

import com.sssw.jms.api.JMQQueue;
import com.sssw.jms.api.JMQDestination;
import com.sssw.jms.api.JMQQueueConnection;
import com.sssw.jms.api.JMQQueueConnectionFactory;

import com.sssw.jms.api.admin.JMQDestinationAdmin;

public class CreateQueue
{
    public static void main(String[] args) throws Exception
    {
	// get the initial context
	InitialContext ctx = new InitialContext();

	// create a destination queue

	// create a JMS Queue Connection
	QueueConnectionFactory qconFactory = (QueueConnectionFactory) ctx.
	    lookup("queue/connectionFactory");
	JMQQueueConnection queueConn = (JMQQueueConnection) qconFactory.
	    createQueueConnection();

	// create a queue
	String queueName = (args.length > 0) ? args[0] : "myQueue";
	JMQDestinationAdmin destAdmin = queueConn.getDestinationAdmin();
	Queue queue = (Queue) destAdmin.createDestination(queueName, 
	    JMQDestination.QUEUE, null);
	System.out.println("Created queue: "+queueName);

	// close the queue connection
	queueConn.close();
    }
}